/*----- PROTECTED REGION ID(Standa8SMC4.h) ENABLED START -----*/
//=============================================================================
//
// file :        Standa8SMC4.h
//
// description : Include file for the Standa8SMC4 class
//
// project :     Standa 8SMC4
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: graziano $
//
// $Revision: 1.4 $
// $Date: 2016-11-11 09:39:26 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef Standa8SMC4_H
#define Standa8SMC4_H

#include <tango.h>
#include <ximc.h>

#define MAX_DEVICES		16


/*----- PROTECTED REGION END -----*/	//	Standa8SMC4.h

/**
 *  Standa8SMC4 class description:
 *    
 */

namespace Standa8SMC4_ns
{
/*----- PROTECTED REGION ID(Standa8SMC4::Additional Class Declarations) ENABLED START -----*/

//	Additional Class Declarations
//class standathread;

/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::Additional Class Declarations

class Standa8SMC4 : public TANGO_BASE_CLASS
{

/*----- PROTECTED REGION ID(Standa8SMC4::Data Members) ENABLED START -----*/

//	Add your own data members
	device_t device;
	move_settings_t move_settings;
	engine_settings_t engine_settings;
	status_t status;
	chart_data_t chart_data;
	device_information_t device_information;
	edges_settings_t edges_settings;
	home_settings_t home_settings;
	void connect_device();
	timespec lastconnection;
	stringstream edgestatus;
	char edgestatus_str[2048];
	stringstream homesetting;
	char homesetting_str[2048];
	char serialdevice_str[2048];
	char stagename_str[2048];
	unsigned long serial_num;

/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::Data Members

//	Device property data members
public:
	//	AxisNumber:	
	Tango::DevLong	axisNumber;
	//	AxisForwardLimit:	
	Tango::DevLong	axisForwardLimit;
	//	AxisBackwardLimit:	
	Tango::DevLong	axisBackwardLimit;
	//	Serialdevice:	
	string	serialdevice;
	//	Serial_timeout:	
	Tango::DevLong	serial_timeout;
	//	Wr_sleep:	
	Tango::DevLong	wr_sleep;
	//	Th_sleep:	
	Tango::DevLong	th_sleep;
	//	PositionRatio:	
	Tango::DevDouble	positionRatio;
	//	Current_position:	
	Tango::DevBoolean	current_position;
	//	Limit_switch_polarity:	
	Tango::DevLong	limit_switch_polarity;
	//	SerialNumber:	
	string	serialNumber;
	//	StageName:	
	string	stageName;

//	Attribute data members
public:
	Tango::DevDouble	*attr_Position_read;
	Tango::DevDouble	*attr_Acceleration_read;
	Tango::DevDouble	*attr_Accuracy_read;
	Tango::DevDouble	*attr_Position_home_read;
	Tango::DevLong	*attr_Stat_read;
	Tango::DevString	*attr_EdgesStatus_read;
	Tango::DevString	*attr_HomingConfig_read;
	Tango::DevString	*attr_Serialdevice_read;
	Tango::DevLong	*attr_SerialNumber_read;
	Tango::DevString	*attr_StageName_read;
	Tango::DevDouble	*attr_Speed_read;

//	Constructors and destructors
public:
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Standa8SMC4(Tango::DeviceClass *cl,string &s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Standa8SMC4(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	Standa8SMC4(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The device object destructor.
	 */
	~Standa8SMC4() {delete_device();};


//	Miscellaneous methods
public:
	/*
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/*
	 *	Initialize the device
	 */
	virtual void init_device();
	/*
	 *	Read the device properties from database
	 */
	void get_device_property();
	/*
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();


//	Attribute methods
public:
	//--------------------------------------------------------
	/*
	 *	Method      : Standa8SMC4::read_attr_hardware()
	 *	Description : Hardware acquisition for attributes.
	 */
	//--------------------------------------------------------
	virtual void read_attr_hardware(vector<long> &attr_list);
	//--------------------------------------------------------
	/*
	 *	Method      : Standa8SMC4::write_attr_hardware()
	 *	Description : Hardware writing for attributes.
	 */
	//--------------------------------------------------------
	virtual void write_attr_hardware(vector<long> &attr_list);

/**
 *	Attribute Position related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_Position(Tango::Attribute &attr);
	virtual void write_Position(Tango::WAttribute &attr);
	virtual bool is_Position_allowed(Tango::AttReqType type);
/**
 *	Attribute Acceleration related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_Acceleration(Tango::Attribute &attr);
	virtual void write_Acceleration(Tango::WAttribute &attr);
	virtual bool is_Acceleration_allowed(Tango::AttReqType type);
/**
 *	Attribute Accuracy related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_Accuracy(Tango::Attribute &attr);
	virtual void write_Accuracy(Tango::WAttribute &attr);
	virtual bool is_Accuracy_allowed(Tango::AttReqType type);
/**
 *	Attribute Position_home related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_Position_home(Tango::Attribute &attr);
	virtual void write_Position_home(Tango::WAttribute &attr);
	virtual bool is_Position_home_allowed(Tango::AttReqType type);
/**
 *	Attribute Stat related methods
 *	Description: 0=standby\n1=moving\n2=resetting to left\n3=resetting to right
 *
 *	Data type:	Tango::DevLong
 *	Attr type:	Scalar
 */
	virtual void read_Stat(Tango::Attribute &attr);
	virtual bool is_Stat_allowed(Tango::AttReqType type);
/**
 *	Attribute EdgesStatus related methods
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_EdgesStatus(Tango::Attribute &attr);
	virtual bool is_EdgesStatus_allowed(Tango::AttReqType type);
/**
 *	Attribute HomingConfig related methods
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_HomingConfig(Tango::Attribute &attr);
	virtual bool is_HomingConfig_allowed(Tango::AttReqType type);
/**
 *	Attribute Serialdevice related methods
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_Serialdevice(Tango::Attribute &attr);
	virtual bool is_Serialdevice_allowed(Tango::AttReqType type);
/**
 *	Attribute SerialNumber related methods
 *	Description: 
 *
 *	Data type:	Tango::DevLong
 *	Attr type:	Scalar
 */
	virtual void read_SerialNumber(Tango::Attribute &attr);
	virtual bool is_SerialNumber_allowed(Tango::AttReqType type);
/**
 *	Attribute StageName related methods
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_StageName(Tango::Attribute &attr);
	virtual bool is_StageName_allowed(Tango::AttReqType type);
/**
 *	Attribute Speed related methods
 *	Description: double[0]: min speed\ndouble[1]: max speed
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Spectrum max = 2
 */
	virtual void read_Speed(Tango::Attribute &attr);
	virtual void write_Speed(Tango::WAttribute &attr);
	virtual bool is_Speed_allowed(Tango::AttReqType type);


	//--------------------------------------------------------
	/**
	 *	Method      : Standa8SMC4::add_dynamic_attributes()
	 *	Description : Add dynamic attributes if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_attributes();




//	Command related methods
public:
	/**
	 *	Command Forward related method
	 *	Description: 
	 *
	 *	@param argin 
	 */
	virtual void forward(Tango::DevDouble argin);
	virtual bool is_Forward_allowed(const CORBA::Any &any);
	/**
	 *	Command Backward related method
	 *	Description: 
	 *
	 *	@param argin 
	 */
	virtual void backward(Tango::DevDouble argin);
	virtual bool is_Backward_allowed(const CORBA::Any &any);
	/**
	 *	Command Stop related method
	 *	Description: 
	 *
	 */
	virtual void stop();
	virtual bool is_Stop_allowed(const CORBA::Any &any);
	/**
	 *	Command MotorOFF related method
	 *	Description: 
	 *
	 */
	virtual void motor_off();
	virtual bool is_MotorOFF_allowed(const CORBA::Any &any);
	/**
	 *	Command MotorON related method
	 *	Description: 
	 *
	 */
	virtual void motor_on();
	virtual bool is_MotorON_allowed(const CORBA::Any &any);
	/**
	 *	Command MotorSTANDBY related method
	 *	Description: 
	 *
	 */
	virtual void motor_standby();
	virtual bool is_MotorSTANDBY_allowed(const CORBA::Any &any);
	/**
	 *	Command GoHome related method
	 *	Description: 
	 *
	 */
	virtual void go_home();
	virtual bool is_GoHome_allowed(const CORBA::Any &any);
	/**
	 *	Command SetHome related method
	 *	Description: 
	 *
	 */
	virtual void set_home();
	virtual bool is_SetHome_allowed(const CORBA::Any &any);
	/**
	 *	Command GoToPosition related method
	 *	Description: 
	 *
	 *	@param argin absolute position in user units
	 */
	virtual void go_to_position(Tango::DevDouble argin);
	virtual bool is_GoToPosition_allowed(const CORBA::Any &any);
	/**
	 *	Command FindEdge related method
	 *	Description: 
	 *
	 *	@param argin 0=find left limit switch 1=find right limit switch
	 */
	virtual void find_edge(Tango::DevLong argin);
	virtual bool is_FindEdge_allowed(const CORBA::Any &any);
	/**
	 *	Command SetHomeValue related method
	 *	Description: Set current Position as argin
	 *
	 *	@param argin Actual Position
	 */
	virtual void set_home_value(Tango::DevDouble argin);
	virtual bool is_SetHomeValue_allowed(const CORBA::Any &any);


	//--------------------------------------------------------
	/**
	 *	Method      : Standa8SMC4::add_dynamic_commands()
	 *	Description : Add dynamic commands if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_commands();

/*----- PROTECTED REGION ID(Standa8SMC4::Additional Method prototypes) ENABLED START -----*/

//	Additional Method prototypes

/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::Additional Method prototypes
};

/*----- PROTECTED REGION ID(Standa8SMC4::Additional Classes Definitions) ENABLED START -----*/

//	Additional Classes Definitions

/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::Additional Classes Definitions

}	//	End of namespace

#endif   //	Standa8SMC4_H
