/*----- PROTECTED REGION ID(Standa8SMC4Class.h) ENABLED START -----*/
//=============================================================================
//
// file :        Standa8SMC4Class.h
//
// description : Include for the Standa8SMC4 root class.
//               This class is the singleton class for
//                the Standa8SMC4 device class.
//               It contains all properties and methods which the 
//               Standa8SMC4 requires only once e.g. the commands.
//
// project :     Standa 8SMC4
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: graziano $
//
// $Revision: 1.4 $
// $Date: 2016-11-11 09:39:26 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef Standa8SMC4Class_H
#define Standa8SMC4Class_H

#include <tango.h>
#include <Standa8SMC4.h>


/*----- PROTECTED REGION END -----*/	//	Standa8SMC4Class.h


namespace Standa8SMC4_ns
{
/*----- PROTECTED REGION ID(Standa8SMC4Class::classes for dynamic creation) ENABLED START -----*/


/*----- PROTECTED REGION END -----*/	//	Standa8SMC4Class::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute Position class definition
class PositionAttrib: public Tango::Attr
{
public:
	PositionAttrib():Attr("Position",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~PositionAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Standa8SMC4 *>(dev))->read_Position(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Standa8SMC4 *>(dev))->write_Position(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Standa8SMC4 *>(dev))->is_Position_allowed(ty);}
};

//	Attribute Acceleration class definition
class AccelerationAttrib: public Tango::Attr
{
public:
	AccelerationAttrib():Attr("Acceleration",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~AccelerationAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Standa8SMC4 *>(dev))->read_Acceleration(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Standa8SMC4 *>(dev))->write_Acceleration(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Standa8SMC4 *>(dev))->is_Acceleration_allowed(ty);}
};

//	Attribute Accuracy class definition
class AccuracyAttrib: public Tango::Attr
{
public:
	AccuracyAttrib():Attr("Accuracy",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~AccuracyAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Standa8SMC4 *>(dev))->read_Accuracy(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Standa8SMC4 *>(dev))->write_Accuracy(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Standa8SMC4 *>(dev))->is_Accuracy_allowed(ty);}
};

//	Attribute Position_home class definition
class Position_homeAttrib: public Tango::Attr
{
public:
	Position_homeAttrib():Attr("Position_home",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~Position_homeAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Standa8SMC4 *>(dev))->read_Position_home(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Standa8SMC4 *>(dev))->write_Position_home(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Standa8SMC4 *>(dev))->is_Position_home_allowed(ty);}
};

//	Attribute Stat class definition
class StatAttrib: public Tango::Attr
{
public:
	StatAttrib():Attr("Stat",
			Tango::DEV_LONG, Tango::READ) {};
	~StatAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Standa8SMC4 *>(dev))->read_Stat(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Standa8SMC4 *>(dev))->is_Stat_allowed(ty);}
};

//	Attribute EdgesStatus class definition
class EdgesStatusAttrib: public Tango::Attr
{
public:
	EdgesStatusAttrib():Attr("EdgesStatus",
			Tango::DEV_STRING, Tango::READ) {};
	~EdgesStatusAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Standa8SMC4 *>(dev))->read_EdgesStatus(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Standa8SMC4 *>(dev))->is_EdgesStatus_allowed(ty);}
};

//	Attribute HomingConfig class definition
class HomingConfigAttrib: public Tango::Attr
{
public:
	HomingConfigAttrib():Attr("HomingConfig",
			Tango::DEV_STRING, Tango::READ) {};
	~HomingConfigAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Standa8SMC4 *>(dev))->read_HomingConfig(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Standa8SMC4 *>(dev))->is_HomingConfig_allowed(ty);}
};

//	Attribute Serialdevice class definition
class SerialdeviceAttrib: public Tango::Attr
{
public:
	SerialdeviceAttrib():Attr("Serialdevice",
			Tango::DEV_STRING, Tango::READ) {};
	~SerialdeviceAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Standa8SMC4 *>(dev))->read_Serialdevice(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Standa8SMC4 *>(dev))->is_Serialdevice_allowed(ty);}
};

//	Attribute SerialNumber class definition
class SerialNumberAttrib: public Tango::Attr
{
public:
	SerialNumberAttrib():Attr("SerialNumber",
			Tango::DEV_LONG, Tango::READ) {};
	~SerialNumberAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Standa8SMC4 *>(dev))->read_SerialNumber(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Standa8SMC4 *>(dev))->is_SerialNumber_allowed(ty);}
};

//	Attribute StageName class definition
class StageNameAttrib: public Tango::Attr
{
public:
	StageNameAttrib():Attr("StageName",
			Tango::DEV_STRING, Tango::READ) {};
	~StageNameAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Standa8SMC4 *>(dev))->read_StageName(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Standa8SMC4 *>(dev))->is_StageName_allowed(ty);}
};

//	Attribute Speed class definition
class SpeedAttrib: public Tango::SpectrumAttr
{
public:
	SpeedAttrib():SpectrumAttr("Speed",
			Tango::DEV_DOUBLE, Tango::READ_WRITE, 2) {};
	~SpeedAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Standa8SMC4 *>(dev))->read_Speed(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Standa8SMC4 *>(dev))->write_Speed(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Standa8SMC4 *>(dev))->is_Speed_allowed(ty);}
};


//=========================================
//	Define classes for commands
//=========================================
//	Command Forward class definition
class ForwardClass : public Tango::Command
{
public:
	ForwardClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ForwardClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ForwardClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Standa8SMC4 *>(dev))->is_Forward_allowed(any);}
};

//	Command Backward class definition
class BackwardClass : public Tango::Command
{
public:
	BackwardClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	BackwardClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~BackwardClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Standa8SMC4 *>(dev))->is_Backward_allowed(any);}
};

//	Command Stop class definition
class StopClass : public Tango::Command
{
public:
	StopClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	StopClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~StopClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Standa8SMC4 *>(dev))->is_Stop_allowed(any);}
};

//	Command MotorOFF class definition
class MotorOFFClass : public Tango::Command
{
public:
	MotorOFFClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	MotorOFFClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~MotorOFFClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Standa8SMC4 *>(dev))->is_MotorOFF_allowed(any);}
};

//	Command MotorON class definition
class MotorONClass : public Tango::Command
{
public:
	MotorONClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	MotorONClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~MotorONClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Standa8SMC4 *>(dev))->is_MotorON_allowed(any);}
};

//	Command MotorSTANDBY class definition
class MotorSTANDBYClass : public Tango::Command
{
public:
	MotorSTANDBYClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	MotorSTANDBYClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~MotorSTANDBYClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Standa8SMC4 *>(dev))->is_MotorSTANDBY_allowed(any);}
};

//	Command GoHome class definition
class GoHomeClass : public Tango::Command
{
public:
	GoHomeClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GoHomeClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GoHomeClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Standa8SMC4 *>(dev))->is_GoHome_allowed(any);}
};

//	Command SetHome class definition
class SetHomeClass : public Tango::Command
{
public:
	SetHomeClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	SetHomeClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~SetHomeClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Standa8SMC4 *>(dev))->is_SetHome_allowed(any);}
};

//	Command GoToPosition class definition
class GoToPositionClass : public Tango::Command
{
public:
	GoToPositionClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GoToPositionClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GoToPositionClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Standa8SMC4 *>(dev))->is_GoToPosition_allowed(any);}
};

//	Command FindEdge class definition
class FindEdgeClass : public Tango::Command
{
public:
	FindEdgeClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	FindEdgeClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~FindEdgeClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Standa8SMC4 *>(dev))->is_FindEdge_allowed(any);}
};

//	Command SetHomeValue class definition
class SetHomeValueClass : public Tango::Command
{
public:
	SetHomeValueClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	SetHomeValueClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~SetHomeValueClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Standa8SMC4 *>(dev))->is_SetHomeValue_allowed(any);}
};


/**
 *	The Standa8SMC4Class singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  Standa8SMC4Class : public Tango::DeviceClass
#else
class Standa8SMC4Class : public Tango::DeviceClass
#endif
{
	/*----- PROTECTED REGION ID(Standa8SMC4Class::Additionnal DServer data members) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4Class::Additionnal DServer data members

	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
	
		//	Method prototypes
		static Standa8SMC4Class *init(const char *);
		static Standa8SMC4Class *instance();
		~Standa8SMC4Class();
		Tango::DbDatum	get_class_property(string &);
		Tango::DbDatum	get_default_device_property(string &);
		Tango::DbDatum	get_default_class_property(string &);
	
	protected:
		Standa8SMC4Class(string &);
		static Standa8SMC4Class *_instance;
		void command_factory();
		void attribute_factory(vector<Tango::Attr *> &);
		void pipe_factory();
		void write_class_property();
		void set_default_property();
		void get_class_property();
		string get_cvstag();
		string get_cvsroot();
	
	private:
		void device_factory(const Tango::DevVarStringArray *);
		void create_static_attribute_list(vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,vector<Tango::Attr *> &);
		vector<string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname);
};

}	//	End of namespace

#endif   //	Standa8SMC4_H
